"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = get;

var _isString = _interopRequireDefault(require("../lang/isString"));

var _escapeRegexp = _interopRequireDefault(require("../string/escapeRegexp"));

function get(key, decoder) {
  if (decoder === void 0) {
    decoder = decodeURIComponent;
  }

  if (!(0, _isString["default"])(key) || !key) {
    return null;
  }

  var reKey = new RegExp("(?:^|; )" + (0, _escapeRegexp["default"])(key) + "(?:=([^;]*))?(?:;|$)");
  var match = reKey.exec(document.cookie);

  if (match === null) {
    return null;
  }

  return typeof decoder === 'function' ? decoder(match[1]) : match[1];
}

module.exports = exports.default;