"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = convert;

var _hasOwn = _interopRequireDefault(require("../../_internal/hasOwn"));

var _computeExpires = _interopRequireDefault(require("./computeExpires"));

// Convert an object to a cookie option string
function convert(opts) {
  var res = '';
  var key;

  for (key in opts) {
    /* istanbul ignore else */
    if ((0, _hasOwn["default"])(opts, key)) {
      if (/^expires$/i.test(key)) {
        var expires = opts[key];

        if (typeof expires !== 'object') {
          expires += typeof expires === 'number' ? 'D' : '';
          expires = (0, _computeExpires["default"])(String(expires));
        }

        res += ";" + key + "=" + expires.toUTCString();
      } else if (/^secure$/.test(key)) {
        if (opts[key]) {
          res += ";" + key;
        }
      } else {
        res += ";" + key + "=" + String(opts[key]);
      }
    }
  }

  if (!(0, _hasOwn["default"])(opts, 'path')) {
    res += ';path=/';
  }

  return res;
}

module.exports = exports.default;