"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = createEvent;

function createEvent(type, options) {
  if (options === void 0) {
    options = {};
  }

  var _options = options,
      _options$bubbles = _options.bubbles,
      bubbles = _options$bubbles === void 0 ? false : _options$bubbles,
      _options$cancelable = _options.cancelable,
      cancelable = _options$cancelable === void 0 ? false : _options$cancelable,
      _options$detail = _options.detail,
      detail = _options$detail === void 0 ? null : _options$detail;
  var event;

  try {
    event = new CustomEvent(type, options);
  } catch (err) {
    /* istanbul ignore next */
    // @ts-ignore
    event = document.createEvent('Event');
    /* istanbul ignore next */
    // @ts-ignore

    if (typeof event.initCustomEvent === 'function') {
      event.initCustomEvent(type, bubbles, cancelable, detail);
    } else {
      event.initEvent(type, bubbles, cancelable); // @ts-ignore

      event.detail = detail;
    }
  }

  return event;
}

module.exports = exports.default;