"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = numberFormat;

var _isNumber = _interopRequireDefault(require("./lang/isNumber"));

function numberFormat(number, digits, dot, sep) {
  if (digits === void 0) {
    digits = -1;
  }

  if (dot === void 0) {
    dot = '.';
  }

  if (sep === void 0) {
    sep = ',';
  }

  if (!(0, _isNumber["default"])(number)) {
    return '';
  }

  var tenExp = Math.pow(10, digits);
  var result = number >= 0 ? '' : '-';
  var decPartStr;

  if (digits > -1) {
    number = Math.round(number * tenExp) / tenExp;
  }

  var abs = Math.abs(number);
  var intPart = Math.floor(abs);
  var decPart = (abs * tenExp - intPart * tenExp) / tenExp;
  var intPartStr = intPart.toString();

  if (decPart === 0) {
    decPartStr = '';
  } else {
    decPartStr = decPart.toString().slice(2);
  }

  if (digits > -1) {
    for (var i = 0; i < digits; i++) {
      if (!decPartStr[i]) {
        decPartStr += '0';
      }
    }

    decPartStr = decPartStr.slice(0, digits);
  }

  var intLen = intPartStr.length;
  var start = intLen % 3;

  for (var _i = 0; _i < intLen; _i++) {
    result += intPartStr[_i];

    if ((_i + 1 - start) % 3 === 0 && _i !== intLen - 1) {
      result += sep;
    }
  }

  if (decPartStr) {
    result += dot;
    result += decPartStr;
  }

  return result;
}

module.exports = exports.default;