"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = truncate;

var _isCJK = _interopRequireDefault(require("../char/isCJK"));

function truncate(str, options) {
  if (str === void 0) {
    str = '';
  }

  if (options === void 0) {
    options = {};
  }

  var _options = options,
      length = _options.length,
      _options$omission = _options.omission,
      omission = _options$omission === void 0 ? '...' : _options$omission,
      _options$countType = _options.countType,
      countType = _options$countType === void 0 ? 0 : _options$countType;
  var ensureStr = String(str);
  var len = ensureStr.length;
  var countLen = length || len;
  var fullCount = countType === 1 ? 2 : 1;
  var halfCount = countType === 2 ? 0.5 : 1;
  var count = 0;
  var i = 0;

  for (; i < len; i++) {
    if ((0, _isCJK["default"])(ensureStr.charAt(i))) {
      count += fullCount;
    } else {
      count += halfCount;
    }

    if (count > countLen) {
      break;
    }
  }

  return "" + ensureStr.slice(0, i) + omission;
}

module.exports = exports.default;